package com.hzya.frame.plugin.grp.service.impl;

import cn.hutool.core.lang.Assert;
import com.alibaba.fastjson.JSONObject;
import com.hzya.frame.grpU8.nxproof.oerdjml.service.IOerDjmlExtService;
import com.hzya.frame.grpU8.nxproof.oerdjml.service.IOerDjmlService;
import com.hzya.frame.plugin.grp.service.IExpensePluginService;
import com.hzya.frame.web.entity.JsonResultEntity;
import org.slf4j.Logger;
import org.slf4j.LoggerFactory;
import org.springframework.beans.factory.annotation.Autowired;

/**
 * @Description grp报销单
 * @Author xiangerlin
 * @Date 2025/3/7 15:39
 **/
public class ExpensePluginServiceImpl implements IExpensePluginService {

    @Autowired
    private IOerDjmlExtService oerDjmlExtService;
    @Autowired
    private IOerDjmlService oerDjmlService;

    Logger logger = LoggerFactory.getLogger(IExpensePluginService.class);
    /**
     * 执行插件
     *
     * @param json
     * @return
     */
    @Override
    public JsonResultEntity execute(JSONObject json)throws Exception {
        String headersStr = json.getString("headers");//请求头
        String formAppId = json.getString("formAppId");
        String eventType = json.getString("eventType");
        String dataSouceCode = json.getString("apiDataSourceCode");
        Assert.notEmpty(formAppId,"formAppId不能为空");
        Assert.notEmpty(eventType,"eventType不能为空");
        Assert.notEmpty(headersStr,"headers不能为空");
        Assert.notEmpty(dataSouceCode,"数据源编码不能为空");
        logger.info("准备开始组装参数");
        String param = oerDjmlExtService.saveExpensePrePlugin(json);
        logger.info("OA单据组装好准备保存GRP的参数:{}",param);
        JSONObject paramJSON = new JSONObject();
        paramJSON.put("jsonStr",param);
        JsonResultEntity resultEntity = (JsonResultEntity) oerDjmlService.handleOerDjml(paramJSON);
        logger.info("保存GRPU8响应参数:{}",JSONObject.toJSON(resultEntity));
        return resultEntity;
    }
}
